package net.cattaka.rdbassistant;

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import javax.swing.JFrame;
import net.cattaka.rdbassistant.gui.RdbAssistantPanel;
import net.cattaka.util.MessageBundle;

public class RdbAssistant {
	static class WindowAdapterEx extends WindowAdapter {
		RdbAssistantPanel rdbAssistantPanel;
		public WindowAdapterEx(RdbAssistantPanel rdbAssistantPanel) {
			this.rdbAssistantPanel = rdbAssistantPanel;
		}
		
		public void windowClosing(WindowEvent e) {
			this.rdbAssistantPanel.doExit();
		}
	}
	
	static class RdbAssistantFrame extends JFrame {
		private static final long serialVersionUID = 1L;
		private RdbAssistantPanel rdbAssistantPanel;
		
		public RdbAssistantFrame() {
			this.rdbAssistantPanel = new RdbAssistantPanel() {
				private static final long serialVersionUID = 1L;
				@Override
				public void doExit() {
					RdbAssistantFrame.this.doExit();
				}
			};
			
			String title = String.format("%s %s - build %s -", MessageBundle.getMessage("rdbassistant_title"), MessageBundle.getReleaseNumber(), MessageBundle.getBuildNumber());
			this.setTitle(title);
			this.setSize(800,600);
			this.getContentPane().add(rdbAssistantPanel);
			this.setJMenuBar(rdbAssistantPanel.getMenuBar());
			this.addWindowListener(new WindowAdapterEx(rdbAssistantPanel));

			rdbAssistantPanel.doGuiLayout();
			rdbAssistantPanel.createWindowRelatedObject();
			
			rdbAssistantPanel.loadRdbaConfig();
			rdbAssistantPanel.reloadRdbaConfig();
		}
		public void doExit() {
			this.rdbAssistantPanel.saveRdbaConfig();
			this.setVisible(false);
			System.exit(0);
		}
	}
	
	public static void main(String[] args) {
		RdbAssistantFrame f = new RdbAssistantFrame();
		f.setVisible(true);
	}
}
